/*
 * DBF/NTX common declarations.
 * Written by Boris Botstein.
 *
 * Source:
 * Rick Spence, "Clipper Programming Guide", Mikrotrend Books.
 */

#ifndef __DBF_UTLS
#define __DBF_UTLS

#include "stl_utls.hpp"
#include "datety.h"

const NTX_PAGE_SIZE = 1024;
const NTX_MAX_KEY_LENGTH = 256;
const DBF_MAX_FIELD_LENGTH = 256;

typedef struct {
	unsigned char signature;
	char date[3];
	long rec_no;
	short length;
	short rec_len;
	char reserved1[3];
	char net[13];
	char reserved2[4];
} dbf_header;

typedef struct {
	char name[11];
	char type;
	long addr;
	unsigned char length;
	unsigned char dec;
	short net1;
	unsigned char id_area;
	short net2;
	unsigned char flag;
	char reserved[8];
	int offset; // My own field.
} dbf_field_desc;

#endif __DBF_UTLS

