#include <windows.h>
#include <string.h>

#pragma hdrstop
#include "stl_utls.hpp"

round_to<2, double> Round;

char* new_str(const char* src) {
	char* dest = new char[::strlen(src) + 1];
	return ::strcpy(dest, src);
}

char* dup_str(const char* src) {
	int cb = ::strlen(src) + 1;
	char* ptr = (char*)::LocalAlloc(LMEM_FIXED, cb);
	if(ptr) ::CopyMemory(ptr, src, cb);
	return ptr;
}

_string get_path(const char* env) {
	char* ptr = ::getenv(env);
	if(ptr) {
		_string temp(ptr);
		if(!temp.empty()) {
			char last = temp[temp.length() - 1];
			if(!(last == '\\' || last == '/')) {
				temp += '\\';
			}
		}
		return _string(temp);
	}
	return _string();
}

_string scrypt(const char* src, unsigned size, bool oem_to_ansi) {
	if(!size) return _string();
	char *tmp = new char[size + 1];
	::memset(tmp, 0, size + 1);
	for(register i = 1; i <= size; i++) {
		unsigned index = (unsigned)(i - 1);
		tmp[index] = (char)(src[index] ^ (((i + 122) % 176) + 21));
	}
	if(oem_to_ansi) ::OemToChar(tmp, tmp);    
	_string rv(tmp);
	delete[] tmp;
	return _string(rv);
}

int32_image::int32_image(const char* _image) {
	initialize();
	::memcpy(image, _image, 4);
	char tmp[4];
	tmp[0] = image[3];
	tmp[1] = image[2];
	tmp[2] = image[1];
	tmp[3] = image[0];
	::memcpy(&value, tmp, 4);
}

int32_image::int32_image(int _value) {
	initialize();
	value = _value;
	char tmp[4];
	::memcpy(tmp, &value, 4);
	image[0] = tmp[3];
	image[1] = tmp[2];
	image[2] = tmp[1];
	image[3] = tmp[0];
}

